// include MIDI library
#include <MIDI.h>
MIDI_CREATE_DEFAULT_INSTANCE();
byte chn = 10; // midi channel
// read digital pins number 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12
byte pushButton2 = 2; //kick
byte pushButton3 = 3; //drm1
byte pushButton4 = 4; //drm2
byte pushButton5 = 5; //multi
byte pushButton6 = 6; //snare
byte pushButton7 = 7; //hh1 close
byte pushButton8 = 8; //hh1 open
byte pushButton9 = 9; //hh2 close
byte pushButton10 = 10; //hh2 open
byte pushButton11 = 11; // clap
byte pushButton12 = 12; // cv sons
byte PadNote[11] = {36, 48, 41, 58, 40, 49, 51, 42, 44, 39, 11}; // 11 = rien
int PotNote = 0;
byte note = 0;
int PotVelo = 0;
byte velo = 0;

// checks if the button is pressed
boolean buttonState2 = 0;
boolean buttonState3 = 0;
boolean buttonState4 = 0;
boolean buttonState5 = 0;
boolean buttonState6 = 0;
boolean buttonState7 = 0;
boolean buttonState8 = 0;
boolean buttonState9 = 0;
boolean buttonState10 = 0;
boolean buttonState11 = 0;
boolean buttonState12 = 0;

// play/stop notes in relation to buttons pressed
boolean note2 = 0;
boolean note3 = 0;
boolean note4 = 0;
boolean note5 = 0;
boolean note6 = 0;
boolean note7 = 0;
boolean note8 = 0;
boolean note9 = 0;
boolean note10 = 0;
boolean note11 = 0;
boolean note12 = 0;

void setup() {
  pinMode(pushButton2, INPUT);
  pinMode(pushButton3, INPUT);
  pinMode(pushButton4, INPUT);
  pinMode(pushButton5, INPUT);
  pinMode(pushButton6, INPUT);
  pinMode(pushButton7, INPUT);
  pinMode(pushButton8, INPUT);
  pinMode(pushButton9, INPUT);
  pinMode(pushButton10, INPUT);
  pinMode(pushButton11, INPUT);
  pinMode(pushButton12, INPUT);
  MIDI.begin();
}

void loop() {
  // read state of buttons
  buttonState2 = digitalRead(pushButton2);
  buttonState3 = digitalRead(pushButton3);
  buttonState4 = digitalRead(pushButton4);
  buttonState5 = digitalRead(pushButton5);
  buttonState6 = digitalRead(pushButton6);
  buttonState7 = digitalRead(pushButton7);
  buttonState8 = digitalRead(pushButton8);
  buttonState9 = digitalRead(pushButton9);
  buttonState10 = digitalRead(pushButton10);
  buttonState11 = digitalRead(pushButton11);
  buttonState12 = digitalRead(pushButton12);
  int PotNote = analogRead(0);
  byte note = map (PotNote, 0, 900, 0, 10);
  int PotVelo = analogRead(1);
  byte velo = map (PotVelo, 0, 1023, 0, 127);


  // play note (note number, velocity, channel)
  // Button 2 KICK
  if (buttonState2 == HIGH) {
    if (note2 == 0) {
      MIDI.sendNoteOn(PadNote[0], velo, chn);
      note2 = 1;
    }
  } else {
    if (note2 == 1) {
      MIDI.sendNoteOff(PadNote[0], 0, chn);
    }
    note2 = 0;
  }

  // Button 3 DRM1
  if (buttonState3 == HIGH) {
    if (note3 == 0) {
      MIDI.sendNoteOn(PadNote[1], velo, chn);
      note3 = 1;
    }
  } else {
    if (note3 == 1) {
      MIDI.sendNoteOff(PadNote[1], 0, chn);
    }
    note3 = 0;
  }

  // Button 4 DRM2
  if (buttonState4 == HIGH) {
    if (note4 == 0) {
      MIDI.sendNoteOn(PadNote[2], velo, chn);
      note4 = 1;
    }
  } else {
    if (note4 == 1) {
      MIDI.sendNoteOff(PadNote[2], 0, chn);
    }
    note4 = 0;
  }

  // Button 5 MULTI
  if (buttonState5 == HIGH) {
    if (note5 == 0) {
      MIDI.sendNoteOn(PadNote[3], velo, chn);
      note5 = 1;
    }
  } else {
    if (note5 == 1) {
      MIDI.sendNoteOff(PadNote[3], 0, chn);
    }
    note5 = 0;
  }

  // Button 6 SNARE
  if (buttonState6 == HIGH) {
    if (note6 == 0) {
      MIDI.sendNoteOn(PadNote[4], velo, chn);
      note6 = 1;
    }
  } else {
    if (note6 == 1) {
      MIDI.sendNoteOff(PadNote[4], 0, chn);
    }
    note6 = 0;
  }

  // Button 7 HIHAT1 CLOSED
  if (buttonState7 == HIGH) {
    if (note7 == 0) {
      MIDI.sendNoteOn(PadNote[5], velo, chn);
      note7 = 1;
    }
  } else {
    if (note7 == 1) {
      MIDI.sendNoteOff(PadNote[5], 0, chn);
    }
    note7 = 0;
  }

  // Button 8 HIHAT1 OPEN
  if (buttonState8 == HIGH) {
    if (note8 == 0) {
      MIDI.sendNoteOn(PadNote[6], velo, chn);
      note8 = 1;
    }
  } else {
    if (note8 == 1) {
      MIDI.sendNoteOff(PadNote[6], 0, chn);
    }
    note8 = 0;
  }

  // Button 9 HIHAT2 CLOSED
  if (buttonState9 == HIGH) {
    if (note9 == 0) {
      MIDI.sendNoteOn(PadNote[7], velo, chn);
      note9 = 1;
    }
  } else {
    if (note9 == 1) {
      MIDI.sendNoteOff(PadNote[7], 0, chn);
    }
    note9 = 0;
  }

  // Button 10 HIHAT2 OPEN
  if (buttonState10 == HIGH) {
    if (note10 == 0) {
      MIDI.sendNoteOn(PadNote[8], velo, chn);
      note10 = 1;
    }
  } else {
    if (note10 == 1) {
      MIDI.sendNoteOff(PadNote[8], 0, chn);
    }
    note10 = 0;
  }

  // Button 11 CLAP
  if (buttonState11 == HIGH) {
    if (note11 == 0) {
      MIDI.sendNoteOn(PadNote[9], velo, chn);
      note11 = 1;
    }
  } else {
    if (note11 == 1) {
      MIDI.sendNoteOff(PadNote[9], 0, chn);
    }
    note11 = 0;
  }

  // Button 12 cv sons
  if (buttonState12 == HIGH) {
    if (note12 == 0) {
      MIDI.sendNoteOn(PadNote[note], velo, chn);
      note12 = 1;
    }
  } else {
    if (note12 == 1) {
      MIDI.sendNoteOff(PadNote[note], 0, chn);
    }
    note12 = 0;
  }
  delay(1); // ???
}

